// C Header File
// Created 15/11/02; 16:59:55

//--------------------------------------------------------------------------
// <structures.h>
// Structures for the Data Bases, the Backup files, the folders of the
// Desktop and the list created by GetSupportedFilesList()
//--------------------------------------------------------------------------

#ifndef __STRUCTURES_H__
#define __STRUCTURES_H__

#include "macros.h"
#include "functions.h"


// Data Bases :
// {
//   unsigned long magic = ICO_MAGIC;
//   unsigned short programs_number;     // number of entries in tha data base
//   DataBaseStruct entries[];     // there are 'programs_number' entries
// }

typedef struct {
	char name[8];     // name of the program
	unsigned short DataSize;     // size of the following data in the structure
	struct { 
 		unsigned short NumRows, NumCols;     // 22,22
 		unsigned char Data[ICON_SIZE];
	} BITMAP; 
	char description[];     // the description displayed at the top of the Desktop
													// The array must have an even number of elements !
													// (add a second '\0' at the end if necessary)
													// TI89 : no more than 20 characters
													// TI92+ / V200 : no more than 32 characters
													// else '...' will be displayed at the end of the string	
} DataBaseStruct;

//--------------------------------------------------------------------------

// the tag before the name of the file in a backup file :
// it's an ASM/PPG/TI-BASIC program  a flash app, a text file, or the fake app
// Refresh Desktop
typedef enum {BCK_PRGM, BCK_FLASH_APP, BCK_REFRESH, BCK_TEXT} BCK_TAG;

// Backup Files :

struct BackupOneFileStruct {
	BCK_TAG file_type;
	char file_name[8];
};

typedef struct {
	char folder_name[8];
	unsigned short programs_number;     // number of programs, text files or apps in this folder
	struct BackupOneFileStruct files[];     // there are 'programs_number' files
} BckFolderStruct;

typedef struct {
	unsigned long magic;     // = BACKUP_MAGIC
	BckFolderStruct folders[DESKTOP_FOLDERS_NUM];
} BackupFileSt;

//--------------------------------------------------------------------------

// The list of the folders of the Desktop :
//   DT_FolderStruct Folders[DESKTOP_FOLDERS_NUM+1];     // +1 for the folder 'All'

typedef struct {
	char folder_name[8];
	unsigned short must_be_null;     // really ?
	HANDLE AppsListHandle;     // handle of the list of the Apps in this folder	
} DT_FolderStruct;

//--------------------------------------------------------------------------

// The list created by GetSupportedFilesList() :
//   FileOfFilesListStruct files[];

typedef struct {
	char name[8];
	union {
		FLIST_ACTION action;     // used in RefreshDesktop()
		AppID CreatedACB;     // written by CreateACBs()
		BOOL Created;     // will be set to FALSE by CreateACBs() if the ACB has not been created
	} TwoBytes;
} FileOfFilesListStruct;


#endif     // #ifndef __STRUCTURES_H__
